<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class AccountModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table="account";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable="account";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	// public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"id", "namaAccount", "deskripsi", "date_updated","noAccount"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"id" => "account.id",
		"namaAccount" => "account.namaAccount",
		"deskripsi" => "account.deskripsi"
	];

    public static function storeFromHO($data)
    {
        $model = (new self())->getQuery()->where("account.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
            $model->namaAccount = $data->namaAccount;
            $model->deskripsi = $data->deskripsi;
            $model->date_updated = $data->date_updated;
            $model->noAccount = $data->noAccount;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Account ".$data->namaAccount." - ".$data->noAccount, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
			$model->id = $data->id;
            $model->namaAccount = $data->namaAccount;
            $model->deskripsi = $data->deskripsi;
            $model->date_updated = $data->date_updated;
            $model->noAccount = $data->noAccount;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Account ".$data->namaAccount." - ".$data->noAccount, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->namaAccount . " sync", PHP_EOL;
    }
	public static function getAccount()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_account";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 14)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Account HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $syncHandler = new \App\Http\Handler\CurlHandler();
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data))
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\AccountModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                    else $fetch = false;
                    $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find(14);
                    $sync->last_sync = $lastUpdate;
                    $sync->update();
                } catch (Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Account HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            } else {
                $fetch = false;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Account HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }

}